export interface Consumer<A> {
    push(a: A, changed?: any): void;
}
export declare class NoopConsumer implements Consumer<any> {
    push(): void;
}
export declare const noopConsumer: NoopConsumer;
export declare class MultiConsumer<A> implements Consumer<A> {
    listeners: Consumer<A>[];
    constructor(c1: Consumer<A>, c2: Consumer<A>);
    push(a: A): void;
}
export declare abstract class Reactive<A> {
    child: Consumer<A>;
    nrOfListeners: number;
    constructor();
    subscribe(fn: (a: A) => void): Consumer<A>;
    addListener(c: Consumer<A>): void;
    removeListener(listener: Consumer<any>): void;
}
/**
 * Things capable of observing behaviors
 */
export interface Observer<A> {
    beginPulling(): void;
    endPulling(): void;
    push(a: A): void;
}
export declare class MultiObserver<A> implements Observer<A> {
    listeners: Observer<A>[];
    constructor(c1: Observer<A>, c2: Observer<A>);
    beginPulling(): void;
    endPulling(): void;
    push(a: A): void;
}
export declare const noopObserver: Observer<any>;
