import { IO } from "jabz/io";
import { Monad } from "jabz/monad";
import { Future } from "./future";
import { Behavior } from "./behavior";
import { Stream } from "./stream";
export declare abstract class Now<A> implements Monad<A> {
    abstract run(): A;
    of<B>(b: B): Now<B>;
    static of<B>(b: B): Now<B>;
    chain<B>(f: (a: A) => Now<B>): Now<B>;
    static multi: boolean;
    multi: boolean;
    flatten: <B>() => Now<B>;
    map: <B>(f: (a: A) => B) => Now<B>;
    mapTo: <B>(b: B) => Now<B>;
    ap: <B>(a: Now<(a: A) => B>) => Now<B>;
    lift: (f: Function, ...ms: any[]) => Now<any>;
}
export declare function async<A>(comp: IO<A>): Now<Future<A>>;
export declare function sample<A>(b: Behavior<A>): Now<A>;
export declare function performStream<A>(s: Stream<IO<A>>): Now<Stream<A>>;
export declare function performStreamLatest<A>(s: Stream<IO<A>>): Now<Stream<A>>;
export declare function performStreamOrdered<A>(s: Stream<IO<A>>): Now<Stream<A>>;
export declare function plan<A>(future: Future<Now<A>>): Now<Future<A>>;
export declare function runNow<A>(now: Now<Future<A>>): Promise<A>;
